%define _disable_ld_no_undefined 1
# fwang: we need to push *.so into main package, because they will be dlopened at runtime, see bug#4882
%define _exclude_files_from_autoreq ^%{_libdir}/libgnc.\\+\\.so$
%define _exclude_files_from_autoprov ^%{_libdir}/libgnc.\\+\\.so$

%define lib_major 0
%define libname %mklibname %{name} %{lib_major}
%define libnamedev %mklibname -d %{name}

%define doc_version 2.4.1
%define build_hbci 1
Name: gnucash
Summary: Application to keep track of your finances
Version: 2.4.10
Release: %mkrel 9
License: GPLv2+
Group: Office
Source0: http://downloads.sourceforge.net/gnucash/%{name}-%{version}.tar.bz2
Source4: http://downloads.sourceforge.net/gnucash/%{name}-docs-%{doc_version}.tar.gz
Source5: engine-common.i
# (fc) 2.2.1-3mdv disable unneeded warning at startup (Fedora)
Patch0: gnucash-quiet.patch
Patch1: gnucash-notsvn.patch
# Guile 2.0 support, patches from Fedora
Patch101: gnucash-guile-1.patch
Patch102: gnucash-guile-2.patch
Patch103: gnucash-guile-3.patch
Patch104: gnucash-guile-4.patch
Patch105: gnucash-guile-5.patch
Patch106: gnucash-guile-6.patch
Patch107: gnucash-guile-7.patch
Patch108: gnucash-guile-8.patch
Patch109: gnucash-guile-9.patch
Patch110: gnucash-guile-10.patch
URL: http://www.gnucash.org/
Requires: guile1.8
Requires: guile1.8-runtime
Requires: slib
Requires: yelp
Suggests: perl-Finance-Quote
# remove for mageia 3
Provides: gnucash-sql
Obsoletes: gnucash-sql <= 2.2.9
BuildRequires: pkgconfig(gconf-2.0) >= 2.0
BuildRequires: pkgconfig(gdk-pixbuf-2.0)
BuildRequires: pkgconfig(glib-2.0) >= 2.13.0
BuildRequires: pkgconfig(gnome-keyring-1) >= 0.6
BuildRequires: pkgconfig(gtk+-2.0) >= 2.10
BuildRequires: pkgconfig(gtkmm-2.4) >= 2.16
BuildRequires: pkgconfig(gwengui-gtk2)
BuildRequires: pkgconfig(gwenhywfar)
BuildRequires: pkgconfig(libglade-2.0) >= 2.4
BuildRequires: pkgconfig(libgnome-2.0) >= 2.19.0
BuildRequires: pkgconfig(libgnomeui-2.0) >= 2.4
BuildRequires: pkgconfig(libgoffice-0.8) >= 0.7.0
BuildRequires: pkgconfig(libofx)
BuildRequires: pkgconfig(libxml-2.0) >= 2.5.10
BuildRequires: pkgconfig(webkit-1.0) >= 1.0
BuildRequires: pkgconfig(guile-1.8)
BuildRequires: dbi-devel
BuildRequires: libktoblzcheck-devel
BuildRequires: python-devel
BuildRequires: intltool
BuildRequires: scrollkeeper
BuildRequires: xsltproc
BuildRequires: slib
BuildRequires: gettext-devel
BuildRequires: swig

%description
GnuCash is a personal finance manager. A check-book like
register GUI allows you to enter and track bank accounts,
stocks, income and even currency trades. The interface is
designed to be simple and easy to use, but is backed with
double-entry accounting principles to ensure balanced books.

%package ofx
Summary: Enables OFX importing in GnuCash
Group: Office
Requires: gnucash = %{version}-%{release}
 
%description ofx
This package adds OFX file import support to the base
GnuCash package. Install this package if you want to
import OFX files.

%if %build_hbci
%package hbci
Summary: Enables HBCI importing in GnuCash
Group: Office
Requires: gnucash = %{version}-%{release}
BuildRequires: pkgconfig(aqbanking) >= 4.0.0
# only require the wizard, it will pull aqhbci package too 
#gw it really required qt3-wizard which wasn't included in aqbanking for a while
Requires: aqhbci

 
%description hbci
This package adds HBCI file import support to the base
GnuCash package. Install this package if you want to
import HBCI files.
%endif

%package -n %{libnamedev}
Group:	Development/C
Summary: Libraries needed to develop for gnucash
Requires: %{libname} = %{version}-%{release}
Provides: %{name}-devel = %{version}-%{release}
Provides: lib%{name}-devel = %{version}-%{release}
Obsoletes: %{name}-devel %mklibname -d %name 0

%description -n %{libnamedev}
Libraries needed to develop for gnucash.

%package -n %{libname}
Summary:        Libraries for gnucash
Group:          System/Libraries
Conflicts:	%{libnamedev} < 2.4.10-3

%description -n %{libname}
This package provides libraries to use gnucash.

%package -n python-gnucash
Summary:        Python module for gnucash
Group:          System/Libraries

%description -n python-gnucash
This package provides python bindings to interact with gnucash.

%prep
%setup -q -a 4
%patch0 -p1 -b .quiet
%patch1 -p1 -b .svn
%if 0
%patch101 -p1
%patch102 -p1
%patch103 -p1
%patch104 -p1
%patch105 -p1
%patch106 -p1
%patch107 -p1
%patch108 -p1
%patch109 -p1
%patch110 -p1
%endif 

cp %{SOURCE5} src/engine

%build
autoreconf -vfi
export BUILDING_FROM_SVN=yes
%configure2_5x --enable-gui  --enable-ofx \
--disable-error-on-warning --disable-schemas-install \
--disable-static \
--enable-locale-specific-tax \
--enable-python-bindings \
--enable-dbi \
--with-html-engine=webkit \
%if %build_hbci
--enable-aqbanking
%endif


cd gnucash-docs-%{doc_version}
%configure2_5x --localstatedir=/var/lib
cd ..

make

cd gnucash-docs-%{doc_version}
%make
cd ..

%install
rm -rf $RPM_BUILD_ROOT %name.lang

%makeinstall_std

cd gnucash-docs-%{doc_version}
%makeinstall_std
cd ..

rm -f $RPM_BUILD_ROOT%{_infodir}/dir
find %buildroot -name '*.la'|xargs rm

#don't ship this file
%{find_lang} %{name} --with-gnome --all-name
for omf in $(ls %buildroot%_datadir/omf/%name-docs/*.omf|fgrep -v -- -C.omf);do 
echo "%lang($(basename $omf|sed -e s/.*-// -e s/.omf//)) $(echo $omf|sed -e s!%buildroot!!)" >> %name.lang
done

# Menu entry 
desktop-file-install --vendor="" \
  --remove-category="Application" \
  --add-category="GTK" \
  --dir $RPM_BUILD_ROOT%{_datadir}/applications $RPM_BUILD_ROOT%{_datadir}/applications/*

# don't ship /usr/bin/gnc-test-env as it's only used for build and testing, this mitigates CVE-2010-3999
rm -f %{buildroot}%{_bindir}/gnc-test-env

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%define schemas apps_gnucash_dialog_business_common apps_gnucash_dialog_commodities apps_gnucash_dialog_common apps_gnucash_dialog_prices apps_gnucash_dialog_print_checks apps_gnucash_dialog_reconcile apps_gnucash_dialog_totd apps_gnucash_general apps_gnucash_history apps_gnucash_import_generic_matcher apps_gnucash_import_qif apps_gnucash_warnings apps_gnucash_window_pages_account_tree apps_gnucash_window_pages_register apps_gnucash_dialog_scheduled_transctions

%preun
%preun_uninstall_gconf_schemas %schemas

%if %build_hbci
%preun hbci
%preun_uninstall_gconf_schemas apps_gnucash_dialog_hbci
%endif


%files -n %{libnamedev}
%defattr(-,root,root)
%{_bindir}/gnucash-make-guids
%{_bindir}/gnucash-valgrind
%{_includedir}/gnucash

%files -n %{libname}
%defattr(-, root, root)
%_libdir/*.so
%_libdir/*.so.*

%files -f %{name}.lang
%defattr(-,root,root)
%_sysconfdir/gconf/schemas/apps_gnucash_dialog_business_common.schemas
%_sysconfdir/gconf/schemas/apps_gnucash_dialog_commodities.schemas
%_sysconfdir/gconf/schemas/apps_gnucash_dialog_common.schemas
%_sysconfdir/gconf/schemas/apps_gnucash_dialog_prices.schemas
%_sysconfdir/gconf/schemas/apps_gnucash_dialog_print_checks.schemas
%_sysconfdir/gconf/schemas/apps_gnucash_dialog_reconcile.schemas
%_sysconfdir/gconf/schemas/apps_gnucash_dialog_scheduled_transctions.schemas
%_sysconfdir/gconf/schemas/apps_gnucash_dialog_totd.schemas
%_sysconfdir/gconf/schemas/apps_gnucash_general.schemas
%_sysconfdir/gconf/schemas/apps_gnucash_history.schemas
%_sysconfdir/gconf/schemas/apps_gnucash_import_generic_matcher.schemas
%_sysconfdir/gconf/schemas/apps_gnucash_import_qif.schemas
%_sysconfdir/gconf/schemas/apps_gnucash_warnings.schemas
%_sysconfdir/gconf/schemas/apps_gnucash_window_pages_account_tree.schemas
%_sysconfdir/gconf/schemas/apps_gnucash_window_pages_register.schemas
%config(noreplace) %{_sysconfdir}/%{name}		
%{_bindir}/gnucash
%{_bindir}/gnucash-env
%{_bindir}/gnc-fq-check
%{_bindir}/gnc-fq-dump
%{_bindir}/gnc-fq-helper
%{_bindir}/gnc-fq-update
%{_bindir}/update-gnucash-gconf
%_datadir/applications/%name.desktop
%dir %{_libdir}/gnucash
%{_libdir}/gnucash/*.so*
%{_libdir}/gnucash/overrides
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/accounts
%{_datadir}/%{name}/checks
%{_datadir}/%{name}/guile-modules
%{_datadir}/%{name}/glade
%{_datadir}/%{name}/pixmaps
%{_datadir}/%{name}/ui
%{_datadir}/%{name}/gnome
%{_datadir}/%{name}/tip_of_the_day.list
%_datadir/icons/hicolor/*/apps/gnucash*
%doc %{_datadir}/%{name}/doc
%{_datadir}/%{name}/scm
%{_mandir}/*/*
%doc AUTHORS COPYING HACKING NEWS README*
%doc doc/README.german doc/README.francais doc/guile-hackers.txt
%dir %{_datadir}/omf/%name-docs/
%{_datadir}/omf/%name-docs/gnucash-guide-C.omf
%{_datadir}/omf/%name-docs/gnucash-help-C.omf
%exclude %{_libdir}/gnucash/libgncmod-ofx*
%if %build_hbci
%exclude %{_libdir}/gnucash/libgncmod-aqbanking*
%exclude %{_datadir}/gnucash/glade/aqbanking*
%exclude %{_datadir}/gnucash/ui/gnc-plugin-aqbanking-ui.xml
%endif
%exclude %{_datadir}/gnucash/ui/gnc-plugin-ofx-ui.xml

%files ofx
%defattr(-,root,root)
%doc doc/README.OFX
%{_libdir}/gnucash/libgncmod-ofx*
%{_datadir}/gnucash/ui/gnc-plugin-ofx-ui.xml

%if %build_hbci
%files hbci
%defattr(-,root,root)
%doc doc/README.HBCI
%_sysconfdir/gconf/schemas/apps_gnucash_dialog_hbci.schemas
%{_libdir}/gnucash/libgncmod-aqbanking*
%{_datadir}/gnucash/glade/aqbanking*
%{_datadir}/gnucash/ui/gnc-plugin-aqbanking-ui.xml
%endif

%files -n python-gnucash
%python_sitelib/%name/
%python_sitearch/%name/


%changelog

* Fri Apr 06 2012 fwang <fwang> 2.4.10-9.mga2
+ Revision: 228913
- requires guile1.8 also

* Wed Apr 04 2012 fwang <fwang> 2.4.10-8.mga2
+ Revision: 228337
- do not force regenerate swig files
- revert build with guile 2.0 to 1.8, as it is not suggested upstream, nor working

* Mon Mar 12 2012 fwang <fwang> 2.4.10-7.mga2
+ Revision: 223056
- really force regenerate swig interface files

* Mon Mar 12 2012 fwang <fwang> 2.4.10-6.mga2
+ Revision: 223052
- do not promote useless png files when building from tarball
- force regenerate swig bindings as suggested by rh#704527

* Mon Mar 12 2012 fwang <fwang> 2.4.10-5.mga2
+ Revision: 222966
- more specific filter
- fix regexp usage

* Mon Mar 12 2012 fwang <fwang> 2.4.10-4.mga2
+ Revision: 222961
- do not provides devel also

* Mon Mar 12 2012 fwang <fwang> 2.4.10-3.mga2
+ Revision: 222957
- move all .so files into lib package, so that it won't fail when dlopen them

* Mon Mar 12 2012 fwang <fwang> 2.4.10-2.mga2
+ Revision: 222844
- fix guile lib loading (1st try on bug#4882)

* Fri Jan 27 2012 fwang <fwang> 2.4.10-1.mga2
+ Revision: 202257
- drop merged patch
- new version 2.4.10

* Sat Jan 21 2012 fwang <fwang> 2.4.9-2.mga2
+ Revision: 198995
- rebuild for new ofx

* Tue Jan 10 2012 fwang <fwang> 2.4.9-1.mga2
+ Revision: 194458
- there is no info file now
- update guile patches
- new version 2.4.9

* Wed Dec 28 2011 wally <wally> 2.4.8-3.mga2
+ Revision: 188477
- add patches from fedora to support new guile 2.0
- sync sources with fedora
- clean .spec a bit

* Wed Nov 30 2011 fwang <fwang> 2.4.8-2.mga2
+ Revision: 174357
- fix build with latest glib
- add br
- br scrollkeeper
- br python-devel
- br slib
- bump rel
- cleanup spec

* Mon Oct 24 2011 fwang <fwang> 2.4.8-1.mga2
+ Revision: 157592
- new version 2.4.8

* Wed Sep 21 2011 fwang <fwang> 2.4.7-3.mga2
+ Revision: 146361
- drop post section
- drop .la files

  + misc <misc>
    - add submodule for python binding
    - fix BR
      add a comment regarding obsoletes
    - enable python binding, and simplify the Requires
    - fix %%post

* Sun Jul 03 2011 fwang <fwang> 2.4.7-1.mga2
+ Revision: 117612
- new version 2.4.7

* Thu Jun 30 2011 ahmad <ahmad> 2.4.6-1.mga2
+ Revision: 116404
- Update to 2.4.6

* Mon Jun 20 2011 dmorgan <dmorgan> 2.4.5-2.mga2
+ Revision: 110695
- Rebuild against new webkit

* Mon Apr 11 2011 dams <dams> 2.4.5-1.mga1
+ Revision: 83229
- Update to 2.4.5

* Thu Mar 24 2011 ennael <ennael> 2.4.4-1.mga1
+ Revision: 76868
- fix build require (thanks to rtp)
- fix build require
- clean apsec file

  + wally <wally>
    - imported package gnucash

